import { Component, OnInit } from '@angular/core';
import { ToastrService } from 'ngx-toastr';
import { AlertService } from 'src/app/services/alert.service';
import { Customer_informationservice} from './Customer_information.service';
import { AbstractControl, FormArray, FormBuilder, FormGroup, Validators, ValidationErrors } from '@angular/forms';
import { ExtensionService } from 'src/app/services/fnd/extension.service';
import { DashboardContentModel2 } from 'src/app/models/builder/dashboard'; 
import { Customer_informationcardvariable } from './Customer_information_cardvariable';
import { UserInfoService } from 'src/app/services/user-info.service';
declare var JsBarcode: any; 
@Component({
  selector: 'app-Customer_information',
  templateUrl: './Customer_information.component.html',
  styleUrls: ['./Customer_information.component.scss']
})
export class Customer_informationComponent implements OnInit {
  cardButton = Customer_informationcardvariable.cardButton;
  cardmodeldata = Customer_informationcardvariable.cardmodeldata;
  public dashboardArray: DashboardContentModel2[];
  isCardview = Customer_informationcardvariable.cardButton;
  cardmodal;  changeView(){
  this.isCardview = !this.isCardview;
  }
    beforeText(fieldtext: string): string { // Extract the text before the first '<'
    const index = fieldtext.indexOf('<');
    return index !== -1 ? fieldtext.substring(0, index) : fieldtext;
  }
  afterText(fieldtext: string): string { // Extract the text after the last '>'
    const index = fieldtext.lastIndexOf('>');
    return index !== -1 ? fieldtext.substring(index + 1) : '';
  }
  transform(fieldtext: string): string {
    const match = fieldtext.match(/<([^>]*)>/);
    return match ? match[1] : ''; // Extract the text between '<' and '>'
  }
 userrole;
  rowSelected :any= {};
  modaldelete=false;
  modalEdit=false;
  modalAdd= false;
  public entryForm: FormGroup;
  loading = false;
  product;
  modalOpenedforNewLine = false;
  newLine:any;
 additionalFieldsFromBackend: any[] = [];
  formcode = 'Customer_information_formCode'
tableName = 'Customer_information';  checkFormCode; selected: any[] = []; constructor(
    private extensionService: ExtensionService,
private userInfoService:UserInfoService,
    private mainService:Customer_informationservice,
    private alertService: AlertService,
    private toastr: ToastrService,
    private _fb: FormBuilder,
  ) { }
// component button
  public insertFormReset_btn: FormGroup;

 
  ngOnInit(): void {
    if(this.cardmodeldata !== ''){
     this.cardmodal = JSON.parse(this.cardmodeldata);
    this.dashboardArray = this.cardmodal.dashboard.slice();
    console.log(this.dashboardArray)
    }
    this.userrole=this.userInfoService.getRoles();
    this.getData();
    this.entryForm = this._fb.group({
customer_name : [null],

contact_person : [null],

email_address : [null],

phone_number: ['+91'],

customer_address : [null],

deployment_type : [null],

  
 
dg_monitoring-without_fuel_:[false],
   

 
active_energy:[false],
   

 
dg_monitoring-with_fuel_:[false],
   

 
ups_monitoring:[false],
   

 
apfc_panel_monitoring:[false],
   

 
busbar_monitoring:[false],
   

 
lt_panel_monitoring:[false],
   

 
ht_panel_monitoring:[false],
   

 
water_management-stp/etp:[false],
   

 
compressed_air-_gas_monitoring:[false],
   

 
compressed_air-lpg/o2/n2/co2:[false],
   

 
water_management-water_monitoring:[false],
   





 















  }); // component_button200
// inser code start
  this.insertFormReset_btn = this._fb.group({
    customer_name: 'text',
    email_address: 'email',
    contact_person: 'text',
    phone_number: 'phone',
    select_objective: 'checkbox',
    reset_btn: 'text',
    customer_address: 'Paragraph',
    deployment_type: 'select',
  });

  // insert code end

 // form code start
    this.extensionService.getJsonObjectsByFormCodeList(this.formcode).subscribe(data => {
      console.log(data);
      const jsonArray = data.map((str) => JSON.parse(str));
      this.additionalFieldsFromBackend = jsonArray;
      this.checkFormCode = this.additionalFieldsFromBackend.some(field => field.formCode === "Customer_information_formCode");
      console.log(this.checkFormCode);
      console.log(this.additionalFieldsFromBackend);
      if (this.additionalFieldsFromBackend && this.additionalFieldsFromBackend.length > 0) {
        this.additionalFieldsFromBackend.forEach(field => {
          if (field.formCode === this.formcode) {
            if (!this.entryForm.contains(field.extValue)) {
              // Add the control only if it doesn't exist in the form
              this.entryForm.addControl(field.extValue, this._fb.control(field.fieldValue));
            }
          }
        });
      }
    });
    console.log(this.entryForm.value);
    // form code end 

















  }
















 error; 
  getData() {
    this.mainService.getAll().subscribe((data) => {
      console.log(data);
      this.product = data;
 if(this.product.length==0){
        this.error="No Data Available"
     }   
    },(error) => {
      console.log(error);
      if(error){
       this.error="Server Error";
     }
    });
  }
  onEdit(row) {
    this.rowSelected = row;

















    this.modalEdit = true;
  }
   onDelete(row) {
    this.rowSelected = row;
     this.modaldelete=true;
  }
  delete(id)
  {
    this.modaldelete = false;
    console.log("in delete  "+id);
    this.mainService.delete(id).subscribe(
      (data) => {
        console.log(data);
        this.ngOnInit();
  if (data) {				      this.toastr.success('Deleted successfully');      }
    });
  }
    onUpdate(id) {
    this.modalEdit = false;
















    //console.log("in update");
    console.log("id  " + id);
    console.log(this.rowSelected);
    //console.log("out update");
    this.mainService.update(id, this.rowSelected).subscribe(
      (data) => {
        console.log(data);
        if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Update Successfully");
        }
setTimeout(() => {
      this.ngOnInit();
    }, 500);
















      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("update Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Updated");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Updated");
        }
      });
    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  } 
onCreate() {
     this.modalAdd=false;
















  this.mainService.create(this.entryForm.value).subscribe(
    (data) => {
      console.log(data);
  if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Added Successfully");
        }
setTimeout(() => {
      this.ngOnInit();
    }, 500);
















      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("Added Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Added");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Added");
        }
      });
    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  }
  goToAdd(row) {
this.modalAdd = true; this.submitted = false;
















  }
 submitted = false;
onSubmit() {
  console.log(this.entryForm.value);
 this.submitted = true;
  if (this.entryForm.invalid) {
    return;
  }this.onCreate();

} 




isValidemail_address(email: string): boolean {
						 const emailPattern = /^[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,}$/;
						    return emailPattern.test(email);   }

isValidPhone_number(phone: string): boolean {
  const phonePattern = /^(\+[1-9][0-9]{0,2})?[1-9][0-9]{9}$/;
  return phonePattern.test(phone);
}

rsModalcustomer_address = false;  
 goToReplaceStringcustomer_address (row){
						    this.rowSelected = row;     this.rsModalcustomer_address  =true;   }







// updateaction

// insert button


modalInsertReset_btn = false; 
goToInsertReset_btn() {
  this.modalInsertReset_btn=true;
  }
onSubmitInsertReset_btn() {
  console.log(this.insertFormReset_btn.value);
  this.submitted=true;
  if (this.insertFormReset_btn.invalid) {
    return;
  }
  this.onInsertReset_btn();
}
onInsertReset_btn() {
    this.modalInsertReset_btn=false;
   this.mainService.insertReset_btnCustomer_information(this.insertFormReset_btn.value).subscribe(data => {
     console.log('After add',data)
     if (data.status >=200 && data.status <=209) {
      this.toastr.success('Added successfully');
  }
if (data && data.id != null) {
        this.toastr.success('Added successfully');
      }  this.ngOnInit();
   },(error) => {
     console.error(error);
     if ( error.status >= 200 && error.status <= 299) {
       this.toastr.success("Update Successfully");
     } 
     if ( error.status >= 400 && error.status <= 499) {
       this.toastr.error("Update Failed");
     } 
     if ( error.status >= 500 && error.status <= 599) {
       this.toastr.error("Server Error");
     } 
     this.ngOnInit();
   });
     this.insertFormReset_btn.reset();
 }
//  insert buuton code end


}












